#Variables Configuracion
$solucion ="default"
$CrmUser = "User"
$CrmPass = "Passwd"
$CrmUrl = "http://crmurl"
$CrmOrg = "OrganizacionOnPremise"


#Función que comprueba que las herramientas de consola CRM estén instaladas 
#realiza la instalación de las mismas si fuera necesario
function InstallXRMPS{
	Set-ExecutionPolicy -Scope Process -ExecutionPolicy Bypass -Force
	$moduleName = "Microsoft.Xrm.Data.Powershell"
	$moduleVersion = "2.7.2"
	if (!(Get-Module -ListAvailable -Name $moduleName )) {
		Write-host "XRM Powershell No encontrado, instalando"
		$moduleVersion
		Install-Module -Name $moduleName -MinimumVersion $moduleVersion -Force
	}
	else
	{
		Write-host "El modulo yaa esta instalado"
	}
}
#Esta función devuelve el objeto de Conexión a CRM necesario para operar con los distintos comandos
function GetCrmConn{
	param(
		[string]$user,
		[string]$secpasswd,
		[string]$crmUrl,
		[string]$organization
		)
	Write-Host "Usuario: $user Password: $secpasswd CrmUrl: $crmUrl"
	$secpasswd2 = ConvertTo-SecureString -String $secpasswd -AsPlainText -Force
	write-host "Creando Credenciales"
	$mycreds = New-Object System.Management.Automation.PSCredential ($User, $secpasswd2)
	
	write-host "Conectando A CRM"
	#Comando Conexion para CRM Online
	#$crm = Connect-CrmOnline -Credential $mycreds -ServerUrl $CrmUrl
	#Comando Conexion para CRM OnPremise
	$crm = Get-CrmConnection -ServerUrl $CrmUrl -Credential $mycreds -OrganizationName $organization
	write-host "Conexion Establecida"
	return $crm
}

#Comprobar/Instalar Módulos
InstallXRMPS
#Datos Conexion Crm
$CrmConn = GetCrmConn -user $CrmUser -secpasswd $CrmPass -crmUrl $CrmUrl -organization $CrmOrg
#Configurar TimeOut Conexion (1000s ~ 16 min)
Set-CrmConnectionTimeout -conn $CrmConn -TimeoutInSeconds 1000

#Prueba de concepto 1 Exportar solución de CRM
Write-Host "Exportando Solucion"
Export-CrmSolution -conn $CrmConn -SolutionName "$solucion" -SolutionZipFileName "$solucion.zip"

#Prueba de concepto 4 Subir solución a CRM
Write-host "Importando Solucion"
Import-CrmSolution -conn $Crm -SolutionFilePath "$solucion.zip"
